import { system, world  } from "@minecraft/server";
import { ActionFormData } from '@minecraft/server-ui';

world.beforeEvents.playerInteractWithEntity.subscribe((data)=>{
    let entity = data.target;
    let player = data.player;
    try {
        if (data.itemStack.typeId.includes("wool")) data.cancel = true;
    } catch {}
    
    system.run(() => { 
        try {
        let item = data.itemStack;
        if (item.typeId.includes("wool")) {
            if (entity.typeId == "minecraft:player") return;
            let teams = ["red", "blue", "green", "yellow", "brown", "orange"];
            let team = data.itemStack.typeId.replace("minecraft:", "").split("_")[0];
            if (teams.includes(team)) {
                data.cancel = true;
                entity.getTags().forEach(element => {
                    if (teams.includes(element)) {
                        entity.removeTag(element);
                    }
                });
                entity.addTag(team);
                entity.addTag("team");
                player.sendMessage("§a"+entity.typeId.replace("minecraft:", "") + " was added to team " + team);
            }
            else if (team == "white") {
                data.cancel = true;
                entity.getTags().forEach(element => {
                    if (teams.includes(element)) {
                        entity.removeTag(element);
                        entity.removeTag("team");
                        player.sendMessage("§a"+entity.typeId.replace("minecraft:", "") + " was removed from team " + element);
                    }
                });
            }
        }
    }
    catch {}
    })

});
world.afterEvents.entityHurt.subscribe((data) => {
    let hurt = data.hurtEntity;
    if (hurt.typeId == "minecraft:player") {
        let teams = ["red", "blue", "green", "yellow", "brown", "orange"];
        let tags = hurt.getTags();
        tags.forEach(element => {
            if (teams.includes(element)) {
                try {
                    let entity = data.damageSource.damagingEntity;
                    if (entity) {
                        if (entity.hasTag(element)){
                            let health = hurt.getComponent("minecraft:health");
                            health.setCurrentValue(health.currentValue + data.damage);
                        }
                    }
                }
                catch {

                }
            }
        });
    }
})
system.afterEvents.scriptEventReceive.subscribe((data) => {
    let id = data.id;
    if (id == "add:teams") {
        let srcplayer = data.sourceEntity;
        let actionform = new ActionFormData().title("players");
        let players = world.getAllPlayers();
        for (const player of players) {
            actionform.button(player.name);
        }
        actionform.show(srcplayer).then((response) => {
            if(response.canceled) return;
            let player = players[response.selection];
            let coloredteams = ["§4red", "§9blue", "§agreen", "§eyellow", "§8brown", "§6orange"];
            let teams = ["red", "blue", "green", "yellow", "brown", "orange"];
            let playerform = new ActionFormData().title(player.name);
            coloredteams.forEach(element => {
                playerform.button(element);
            });
            playerform.body("Current Team: none");
            player.getTags().forEach(element => {
                if (teams.includes(element)) {
                    playerform.body("Current Team: " + element);
                }
            });
            playerform.button("remove team");
            playerform.show(srcplayer).then(response => {
                if (response.canceled) return;
                if (response.selection == 6) {
                    let tags = player.getTags();
                    tags.forEach(element => {
                        if (teams.includes(element)) {
                            player.removeTag(element);
                            player.sendMessage("§aYou were removed from team "+ element);
                            if (player.name != srcplayer.name) srcplayer.sendMessage("§a"+player.name+" is removed from team "+ element);
                        }
                    });
                    player.removeTag("team");
                    return;
                }
                let tags = player.getTags();
                tags.forEach(element => {
                    if (teams.includes(element)) {
                        player.removeTag(element);
                    }
                });
                player.addTag(teams[response.selection]);
                player.addTag("team");
                player.sendMessage("§aYou were added to team "+ teams[response.selection]);
                if (player.name != srcplayer.name) srcplayer.sendMessage("§a"+player.name+" is added to team "+ teams[response.selection]);
            })
        })
    }
})
